libreorganize/apps/events/urls.py
from django.urls import path

from apps.events import utils, views

app_name = "apps.events"

urlpatterns = [
    # Require VIEW permissions
    path("", views.ListView.as_view(), name="list"),
    # Require MANAGE permissions
    path("create/", views.CreateView.as_view(), name="create"),
    path("<int:pk>/edit/", views.EditView.as_view(), name="edit"),
    path("<int:pk>/delete/", views.DeleteView.as_view(), name="delete"),
    path("<int:pk>/check/", views.CheckView.as_view(), name="check"),
    # Require NO permissions
    path("<int:pk>/", views.DetailView.as_view(), name="detail"),
    path("calendar/", views.CalendarView.as_view(), name="calendar"),
    path("subscribe/", utils.EventFeed(), name="subscribe"),
]

libreorganize/core/urls.py
import os

from django.conf import settings
from django.conf.urls.static import static
from django.urls import include, path
from django.views.generic import TemplateView

urlpatterns = []

if os.path.exists(os.path.join(settings.BASE_DIR, "theme")):
    from theme.urls import *

urlpatterns += [
    path("", TemplateView.as_view(template_name="home.html"), name="home"),
    path("accounts/", include("apps.accounts.urls", namespace="accounts")),
    path("boxes/", include("apps.boxes.urls", namespace="boxes")),
    path("events/", include("apps.events.urls", namespace="events")),
    path("news/", include("apps.news.urls", namespace="news")),
    path("votations/", include("apps.votations.urls", namespace="votations")),
    path("wikis/", include("apps.wikis.urls", namespace="wikis")),
    path("i18n/", include("django.conf.urls.i18n")),
    path("ckeditor/", include("ckeditor_uploader.urls")),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

libreorganize/apps/events/models.py
from django.conf import settings
from django.db import models
from django.utils.translation import gettext_lazy as _

from apps.accounts.models import Account


class Event(models.Model):
    title = models.CharField(max_length=48)
    description = models.TextField(blank=True)
    start_date = models.DateTimeField(help_text=_("Must be formatted as YYYY-MM-DD HH:MM"))
    end_date = models.DateTimeField(help_text=_("Must be formatted as YYYY-MM-DD HH:MM"))
    location = models.CharField(max_length=128, help_text=_("Should be an address"))
    max_participants = models.IntegerField(default=-1, help_text=_("Enter -1 for an unlimited number of participants"))
    participants = models.ManyToManyField(Account, blank=True)
    is_private = models.BooleanField(default=False, help_text=_("Must be logged in to view the event"))
    occurrences = models.IntegerField(default=1, help_text=_("Must be a value between 1 and 12"))
    frequency = models.CharField(
        choices=settings.FREQUENCY_CHOICES,
        help_text=_("Ignore if there is only one occurrence"),
        max_length=12,
        default="weekly",
    )
    previous = models.OneToOneField(
        "Event", on_delete=models.CASCADE, null=True, editable=False, related_name="subsequent"
    )
    sent = models.BooleanField(default=False)
    can_check_in = models.BooleanField(default=True, help_text="Allow atendees to check in to this event")

    class Meta:
        default_permissions = ()
        permissions = (
            ("view_events", "View events"),
            ("manage_events", "Manage events"),
        )

libreorganize/apps/events/views.py
import copy
from datetime import datetime, timedelta
from itertools import chain

from dateutil.relativedelta import relativedelta
from django.contrib import messages
from django.http import HttpResponseRedirect
from django.shortcuts import render
from django.urls import reverse
from django.utils.translation import gettext_lazy as _
from django.views import View

from apps.events.forms import CreateEventForm, EventForm
from apps.events.models import Event
from apps.events.utils import Calendar, get_date, next_month, prev_month
from core.mixins import ModelMixin, PermissionMixin
from core.views import CoreCreateView, CoreDeleteView, CoreDetailView, CoreEditView, CoreListView


class ListView(CoreListView):
    personal = False
    permission = "events.view_events"
    model = Event
    template_name = "events/list.html"

    def get(self, request):
        previous_btn = {"active": "", "pressed": "", "href": "?status=1", "text": "Show"}
        event_list = Event.objects.all()
        event_list = event_list.filter(start_date__gte=datetime.now())

        if self.request.GET.get("status", None) == "0":
            event_list = event_list.filter(start_date__gte=datetime.now())
            previous_btn = {"active": "active", "pressed": "", "href": "?status=1", "text": "Show"}
        elif self.request.GET.get("status", None) == "1":
            event_list = Event.objects.all()
            previous_btn = {"active": "", "pressed": "true", "href": "?status=0", "text": "Hide"}

        return render(
            request=request,
            template_name=self.template_name,
            context={"event_list": event_list, "previous_btn": previous_btn},
        )


class DetailView(CoreDetailView):
    personal = False
    permission = False
    model = Event
    template_name = "events/detail.html"

    def get(self, request):
        if not self.request.user.is_authenticated and self.event.is_private:
            return HttpResponseRedirect(reverse("accounts:login") + "?next=" + request.get_full_path())
        return super().get(request)


class CreateView(CoreCreateView):
    personal = False
    permission = "events.manage_events"
    model = Event
    form_name = CreateEventForm
    template_name = "events/create.html"

    def get_context(self):
        context = super().get_context()
        if self.request.GET.get("start_date", None):
            context["form"].initial["start_date"] = datetime.fromtimestamp(int(self.request.GET["start_date"]))
        return context

    def post(self, request):
        form = CreateEventForm(request.POST)
        if form.is_valid():
            # Save the form results
            self.event = form.save()
            messages.success(request, _("The event has been successfully created."))

            if self.event.occurrences > 1:
                delta = relativedelta(weeks=1)
                if self.event.frequency == "monthly":
                    delta = relativedelta(months=1)
                elif self.event.frequency == "yearly":
                    delta = relativedelta(years=1)

                for occurrence in range(self.event.occurrences - 1):
                    new_event = copy.copy(self.event)
                    new_event.pk = None
                    new_event.previous = self.event
                    new_event.start_date = self.event.start_date + delta
                    new_event.end_date = self.event.end_date + delta
                    new_event.save(force_insert=True)
                    self.event = new_event
            return HttpResponseRedirect(self.next)
        return render(request=request, template_name="events/edit.html", context={"form": form})


class EditView(CoreEditView):
    personal = False
    permission = "events.manage_events"
    model = Event
    form_name = EventForm
    template_name = "events/edit.html"

    def get_context(self):
        context = super().get_context()
        context["event"] = self.event
        return context

    def post(self, request):
        form = EventForm(request.POST, instance=self.event)
        if form.is_valid():
            # Check if we are editing only that event
            if "modalRadio" in self.request.POST and self.request.POST["modalRadio"] == "1":
                event = form.save()

            # Check if we are editing multiple events
            if "modalRadio" in self.request.POST and (
                self.request.POST["modalRadio"] == "2" or self.request.POST["modalRadio"] == "3"
            ):
                start_delta = form.cleaned_data["start_date"] - form.initial["start_date"]
                end_delta = form.cleaned_data["end_date"] - form.initial["end_date"]
                event = self.event

                # If updating all objects, start with the original object; otherwise start with the current object
                if self.request.POST["modalRadio"] == "3":
                    while event.previous is not None:
                        event = event.previous

                # For every object, update the attributes and adjust the start & end times
                try:
                    # Save the many-to-many fields and generic relations for this form.
                    cleaned_data = form.cleaned_data
                    exclude = form._meta.exclude
                    fields = form._meta.fields
                    opts = form.instance._meta

                    # don't set start_date and end_date
                    if exclude is None:
                        exclude = ["start_date", "end_date"]

                    while True:
                        for f in fields:
                            if f not in exclude and not f == "participants":
                                setattr(event, f, cleaned_data[f])

                        for f in chain(opts.many_to_many):
                            # if f.name in exclude:
                            #     continue
                            if f.name in cleaned_data:
                                f.save_form_data(event, cleaned_data[f.name])

                        if event.pk != self.event.pk:
                            event.start_date = event.start_date + start_delta
                            event.end_date = event.end_date + end_delta

                        event.save()  # save the object
                        event = event.subsequent  # now repeat for next object in list
                except Event.DoesNotExist:
                    pass
            messages.success(request, _("The event has been successfully edited."))
            return HttpResponseRedirect(self.next)
        return render(request=request, template_name="events/edit.html", context={"form": form})


class DeleteView(CoreDeleteView):
    personal = False
    permission = "events.manage_events"
    model = Event
    template_name = "events/delete.html"

    def get_context(self):
        context = super().get_context()
        context["event"] = self.event
        return context

    def post(self, request):
        if "modalRadio" in self.request.POST and self.request.POST["modalRadio"] == "1":
            event = self.event
            try:
                subsequent = event.subsequent
                subsequent.previous = event.previous
                event.previous = None
                event.save()
                subsequent.save()
            except Event.DoesNotExist:
                pass
        self.event.delete()
        messages.success(request, _("The event has been successfully deleted."))
        return HttpResponseRedirect(self.next)


class CalendarView(View):
    def get(self, request, *args, **kwargs):
        date = get_date(self.request.GET.get("month", None))
        calendar = Calendar(date.year, date.month)

        context = {
            "calendar": calendar.formatmonth(withyear=True, privateevents=request.user.is_authenticated),
            "prev_month": prev_month(date),
            "next_month": next_month(date),
            "date": date,
        }

        return render(request=request, template_name="events/calendar.html", context=context)


class CheckView(PermissionMixin, ModelMixin, View):
    personal = False
    permission = True
    model = Event

    def get(self, request):
        # Redirect if checking in is not enabled for this event
        if not self.event.can_check_in:
            messages.add_message(request, messages.ERROR, _("You cannot check in to this event."))
            return HttpResponseRedirect(reverse("events:detail", args={self.event.pk}))

        event_start = self.event.start_date - timedelta(days=1)
        event_end = self.event.end_date + timedelta(days=1)
        if request.user in self.event.participants.all():
            messages.add_message(request, messages.WARNING, _("You have already checked in!"))
        else:
            if self.event.participants.count() >= self.event.max_participants and self.event.max_participants != -1:
                messages.add_message(request, messages.ERROR, _("There are no more empty seats for this event!"))
            elif event_start < datetime.now() < event_end:
                self.event.participants.add(request.user)
                messages.add_message(request, messages.SUCCESS, _("You checked in."))
            else:
                messages.add_message(
                    request, messages.ERROR, _("You can only check in 24 hours before and after an event.")
                )
        return HttpResponseRedirect(reverse("events:detail", args={self.event.pk}))

libreorganize/apps/events/templates/events/calendar.html
{% extends "base.html" %}
{% load static %}
{% load i18n %}

{% block title %}{% trans 'Calendar' %}{% endblock %}
{% block extra_head %}
<link rel="stylesheet" type="text/css" href="{% static 'css/events.css' %}">
{% endblock %}

{% block content %}
<div class="row no-gutters card-row">
    <div class="col-11 mx-auto my-auto">
        <div class="card">
            <div class="card-header events-header">
                <a class="btn btn-dark" style="margin: 0 !important;" href="{% url 'events:calendar' %}?{{ prev_month }}"><i
                        class="fas fa-arrow-left fa-fw"></i>
                </a>
                <h1 class="text-center">{{ date|date:"F Y" }}</h1>

                <a class="btn btn-dark" style="margin: 0 !important;" href="{% url 'events:calendar' %}?{{ next_month }}"><i
                    class="fas fa-arrow-right fa-fw"></i>
                </a>
            </div>
            <div class="card-body">
                <div class="table-responsive">
                    {{ calendar }}
                </div>
            </div>
        </div>
    </div>
</div>
{% endblock %}

libreorganize/apps/events/templates/events/create.html
{% extends "core/form.html" %}
{% load i18n %}

{% block title %}{% trans "Create Event" %}{% endblock title %}

{% block form_title %}
<h1>{% trans "Create Event" %}</h1>
{% endblock form_title %}

{% block extra_js %}
<script>
    Date.prototype.addHours = function(h) {
        this.setTime(this.getTime() + (h*60*60*1000));
        return this;
    }

    function pad(n) {
        return n.toString().padStart(2, "0");
    }

    let startDate = document.querySelector("#id_start_date");
    let endDate = document.querySelector("#id_end_date");

    endDate.addEventListener("focus", function(e) {
        let newDate = new Date(Date.parse(startDate.value)).addHours(1);
        let newDateString = newDate.getFullYear() + "-" + pad(newDate.getMonth() + 1) + "-" + pad(newDate.getDate()) + " " + pad(newDate.getHours()) + ":" + pad(newDate.getMinutes());
        endDate.value = newDateString;
    });
</script>
{% endblock extra_js %}

libreorganize/apps/events/templates/events/delete.html
{% extends "base.html" %}
{% load i18n %}

{% block title %}{% trans 'Delete Event' %}{% endblock %}

{% block content %}
<div class="container">
    <div class="row card-row">
        <div class="col-12 col-sm-9 col-lg-6 mx-auto my-auto">
            <div class="card">
                <div class="card-header text-center">
                    <h1 class="text-center">{% trans "Delete Event" %}</h1>
                </div>
                <div class="card-body">
                    <form novalidate method="post">
                        {% csrf_token %}
                        <div class="form-group text-center">
                            {% trans "Are you sure you want to delete the event?" %}
                            <br>
                            {% trans "This action is irreversible." %}
                        </div>
                        <hr>
                        <div class="d-flex justify-content-between" style="flex-wrap: wrap;">
                            <div>
                                <a class="btn btn-secondary {% if not request.GET.next %}disabled{% endif %}" href="{{ request.GET.next }}">
                                    <i class="fas fa-arrow-left"></i>
                                </a>
                            </div>
                            <div>
                                {% block extra_form_buttons %}{% endblock extra_form_buttons %}
                                {% if event.subsequent %}
                                <button type="button" class="btn btn-danger" data-toggle="modal" data-target="#deleteModal"><i
                                        class="fas fa-trash fa-fw mr-1"></i>{% trans "Delete" %}</button>
                                {% else %}
                                <button type="submit" class="btn btn-danger"><i
                                        class="fas fa-trash fa-fw mr-1"></i>{% trans "Delete" %}</button>
                                {% endif %}
                            </div>
                        </div>
                        <div class="modal fade" id="deleteModal" tabindex="-1" role="dialog" aria-labelledby="deleteModalLabel"
                            aria-hidden="true">
                            <div class="modal-dialog modal-dialog-centered" role="document">
                                <div class="modal-content">
                                    <div class="modal-header">
                                        <h5 class="modal-title" id="deleteModalLabel">Delete recurring event</h5>
                                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                            <span aria-hidden="true">&times;</span>
                                        </button>
                                    </div>
                                    <div class="modal-body">
                                        <div class="custom-control custom-radio">
                                            <input type="radio" id="thisRadio" name="modalRadio" class="custom-control-input" value="1"
                                                checked>
                                            <label class="custom-control-label" for="thisRadio">This event</label>
                                        </div>
                                        <div class="custom-control custom-radio">
                                            <input type="radio" id="followingRadio" name="modalRadio" class="custom-control-input"
                                                value="2">
                                            <label class="custom-control-label" for="followingRadio">This and following events</label>
                                        </div>
                                    </div>
                                    <div class="modal-footer">
                                        <button type="submit" class="btn btn-danger"><i
                                                class="fas fa-trash fa-fw mr-1"></i>{% trans "Delete" %}</button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
{% endblock %}

libreorganize/apps/events/templates/events/detail.html
{% extends "base.html" %}
{% load i18n %}

{% block title %}{{ event.title }}{% endblock %}

{% block content %}
<div class="container">
    <div class="row no-gutters card-row">
        <div class="col-12 mx-auto my-auto">
            <div class="card">
                <div class="card-header text-center">
                    <h1>{{ event.title }}</h1>
                </div>
                <div class="card-body">
                    <div class="container">
                        <div class="row">
                            <div class="col-md-4 col-lg-3 px-0 pr-md-2 pb-3">
                                {% if user in event.participants.all %}
                                <a class="btn btn-success btn-detail disabled" href="{% url 'events:check' pk=event.pk %}"><i
                                        class="fas fa-check fa-fw mr-1"></i>{% trans "Checked in" %}</a>
                                {% else %}
                                {% if event.can_check_in %}
                                <a class="btn btn-success btn-detail" href="{% url 'events:check' pk=event.pk %}"><i
                                        class="fas fa-check fa-fw mr-1"></i>{% trans "Check in" %}</a>
                                {% endif %}
                                {% endif %}
                                {% if perms.events.manage_events %}
                                <a class="btn btn-warning btn-detail"
                                    href="{% url 'events:edit' pk=event.pk %}?next={{ request.get_full_path }}"><i
                                        class="fas fa-pen fa-fw mr-1"></i>{% trans "Edit Event" %}</a>
                                <a class=" btn btn-danger btn-detail"
                                    href="{% url 'events:delete' pk=event.pk %}?next={{ request.get_full_path }}"><i
                                        class="fas fa-trash fa-fw mr-1"></i>{% trans "Delete Event" %}</a>
                                {% endif %}
                            </div>
                            <div class="col-md-8 col-lg-9 px-0 pl-md-2">
                                <div class="table-responsive">
                                    <table class="table table-striped">
                                        <tbody>
                                            <tr>
                                                <th scope="row">Event ID</th>
                                                <td>{{ event.pk }}</td>
                                            </tr>
                                            <tr>
                                                <th scope="row">{% trans "Title" %}</th>
                                                <td>{{ event.title }}</td>
                                            </tr>
                                            <tr>
                                                <th scope="row">{% trans "Description" %}</th>
                                                <td>{{ event.description|urlize }}</td>
                                            </tr>
                                            <tr>
                                                <th scope="row">{% trans "Start Date" %}</th>
                                                <td>{{ event.start_date }}</td>
                                            </tr>
                                            <tr>
                                                <th scope="row">{% trans "End Date" %}</th>
                                                <td>{{ event.end_date }}</td>
                                            </tr>
                                            <tr>
                                                <th scope="row">{% trans "Location" %}</th>
                                                <td>{{ event.location }}</td>
                                            </tr>
                                            <tr>
                                                <th scope="row">{% trans "Max Participants" %}</th>
                                                {% if event.max_participants == -1 %}
                                                <td>&#8734;</td>
                                                {% else %}
                                                <td>{{ event.max_participants }}</td>
                                                {% endif %}
                                            </tr>
                                            <tr>
                                                <th scope="row">{% trans "Participants" %}</th>
                                                <td>
                                                    {% for participant in event.participants.all %}
                                                    <a
                                                        href="{% url 'accounts:detail' pk=participant.pk %}?next={{ request.get_full_path }}">{{ participant.full_name }}</a><br>
                                                    {% endfor %}
                                                </td>
                                            </tr>
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
{% endblock %}

libreorganize/apps/events/templates/events/list.html
{% extends "base.html" %}
{% load i18n %}

{% block title %}{% trans 'Events' %}{% endblock %}

{% block content %}
<div class="container">
    <div class="row card-row">
        <div class="col-12 mx-auto my-auto">
            <div class="card">
                <div class="card-header text-center">
                    <h1>{% trans "Events" %}</h1>
                </div>
                <div class="card-body">
                    <table id="jsTable" class="table table-striped nowrap" style="width: 100%;">
                        <thead>
                            <tr>
                                <th scope="col">Event ID</th>
                                <th scope="col">{% trans "Title" %}</th>
                                <th scope="col">{% trans "Date" %}</th>
                                <th scope="col">{% trans "Participants" %}</th>
                                <th scope="col">{% trans "Max Participants" %}</th>
                                <th scope="col">
                                    {% if perms.events.manage_events %}
                                    <a class="btn btn-sm btn-success" href="{% url 'events:create' %}?next={{ request.get_full_path }}"
                                        data-toggle="tooltip" title="{% trans 'Create Event' %}">
                                        <i class="fas fa-plus fa-fw"></i>
                                    </a>
                                    {% endif %}
                                    <a class="btn btn-sm btn-info" href="{% url 'events:calendar' %}" data-toggle="tooltip"
                                        title="{% trans 'Calendar' %}">
                                        <i class="fas fa-calendar-alt fa-fw"></i>
                                    </a>
                                    <a class="btn btn-sm btn-secondary" class="btn btn-primary" data-toggle="modal"
                                        data-target="#icalsubscribe">
                                        <i class="fas fa-download fa-fw"></i>
                                    </a>
                                </th>

                            </tr>
                        </thead>
                        <tbody>
                            {% for event in event_list %}
                            <tr>
                                <td>{{ event.pk }}</td>
                                <td>{{ event.title }}</td>
                                <td>{{ event.start_date }}</td>
                                <td>{{ event.participants.count }}</td>
                                {% if event.max_participants == -1 %}
                                <td>&#8734;</td>
                                {% else %}
                                <td>{{ event.max_participants }}</td>
                                {% endif %}
                                <td>
                                    <a class="btn btn-sm btn-info" href="{% url 'events:detail' pk=event.pk %}" data-toggle="tooltip"
                                        title="{% trans 'Detail Event' %}">
                                        <i class="fas fa-eye fa-fw"></i>
                                    </a>
                                    {% if perms.events.manage_events %}
                                    <a class="btn btn-sm btn-warning"
                                        href="{% url 'events:edit' pk=event.pk %}?next={{ request.get_full_path }}" data-toggle="tooltip"
                                        title="{% trans 'Edit Event' %}">
                                        <i class="fas fa-pen fa-fw"></i>
                                    </a>
                                    <a class="btn btn-sm btn-danger"
                                        href="{% url 'events:delete' pk=event.pk %}?next={{ request.get_full_path }}" data-toggle="tooltip"
                                        title="{% trans 'Delete Event' %}">
                                        <i class="fas fa-trash fa-fw"></i>
                                    </a>
                                    {% endif %}
                                </td>
                            </tr>
                            {% endfor %}
                        </tbody>
                    </table>
                    <hr>
                    <div class="container-fluid no-gutters">
                        <div class="row">
                            <a class="btn btn-outline-secondary {{ previous_btn.active }}" data-toggle="button"
                                aria-pressed="{{ previous_btn.pressed }}" href="{% url 'events:list' %}{{ previous_btn.href }}">
                                {{ previous_btn.text }} <span class="badge badge-success font-weight-normal"><i
                                        class='fas fa-history fa-fw'></i> PREVIOUS EVENTS</span>
                            </a>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
<div class="modal fade" id="icalsubscribe" tabindex="-1" role="dialog" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title">iCal Subscribe</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <p>Downloading the iCal will not update your calendar each time a new event is created</p>
                <div class="input-group mb-3">
                    <input type="text" id="linktoical" class="form-control" value="{{ request.get_host }}{% url 'events:subscribe' %}"
                        readonly>
                    <div class="input-group-append">
                        <a class="btn btn-outline-secondary" onclick="copyClipboard()"><i class="fas fa-clipboard fa-fw"></i></a>
                        <a type="button" class="btn btn-outline-primary" href="{% url 'events:subscribe' %}">
                            <i class="fas fa-download"></i>
                        </a>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
<script>
    function copyClipboard() {
        var copyText = document.getElementById("linktoical");
        copyText.select();
        document.execCommand("copy");
    }
</script>
{% endblock content%}